VERSION 1.0 CLASS
BEGIN
  MultiUse = -1 'True
END
Attribute VB_PredeclaredId = False
Attribute VB_Creatable = True
Attribute VB_Exposed = False
Attribute VB_GlobalNameSpace = False
Attribute VB_Name = "CountryCode"
'#Reference {5BAA3B30-7D07-46D2-948A-1551CBFD2BB4}#1.0#0#C:\Program Files\photools.com\IMatch36\IMatchADT.dll#IMatch 3 Scripting Helper 1.0 Type Library#IMATCHADTLib
'CountryCode.CLS
'File|New Module|Class Module
'Edit|Properties|Name=CountryCode
Option Explicit

' to process IPTC countries and codes in sync, if needed
Private countries As New IMDictionary
Private codes As New IMDictionary

Private countryName As String
Private countryCode As String

Public Property Get Country As String
	Country=countryName
End Property

Public Property Get Code As String
	Code=countryCode
End Property


Public Function IsCountryName(Code As String) As Boolean

	Dim result As Boolean

	Code = UCase(Code)

    If codes.Exists(Code) Then
    	result= True
		countryName=GetCountryName(Code)
    Else
		result=False
		countryName=""
    End If

    IsCountryName=result

End Function

Public Function IsCountryCode(Country As String) As Boolean

	Dim result As Boolean

	Country = PCase(Country)

    If countries.Exists(Country) Then
        countryCode=GetCountryCode(Country)
    	result= True
    Else
		result=False
		countryCode=""
    End If

    IsCountryCode=result

End Function

' ----------------------------------------- Private

Private Function GetCountryName(Code As String) As String

    If codes.Exists(Code) Then
    	GetCountryName= codes(Code)
    Else
		GetCountryName=Nothing
    End If

End Function

Private Function GetCountryCode(Country As String) As String

    If countries.Exists(Country) Then
    	GetCountryCode= countries(Country)
    Else
		GetCountryCode=Nothing
    End If

End Function

' -------------------------------------------------

    ''' <summary>
    ''' -----------------------------------------------------
    ''' Alle Anfangsbuchstaben des Eingabe String strText werden
    ''' in Grobuchstaben umgewandelt alle anderen in Klein-
    ''' buchsraben umgewandelt.
    ''' Das Leerzeichen und das "-" Zeiche dienen als Wort-
    ''' trenner.
    ''' -----------------------------------------------------
    ''' </summary>
    ''' <param name="strText">der Eingabe String</param>
    ''' <returns>den umgewandelten String</returns>
    ''' <remarks></remarks>
    Private Function PCase(ByVal strText As String) As String
        On Error GoTo Err_PCase

        Dim i As Integer, intLen As Integer, strTemp As String, strFinal As String
        Dim isSpace As Boolean

        strTemp = LCase(Trim(strText))
        intLen = Len(Trim(strText))
        strFinal = String(intLen, " ")
        isSpace = True

        For i = 1 To intLen
            If Mid(strTemp, i, 1) = Chr(32) Then
                strFinal = Mid(strFinal, 1, i - 1) & Chr(32) & Mid(strFinal, i + 1)
                isSpace = True
            ElseIf Mid(strTemp, i, 1) = "-" Then
                strFinal = Mid(strFinal, 1, i - 1) & "-" & Mid(strFinal, i + 1)
                isSpace = True
            ElseIf isSpace Then
                strFinal = Mid(strFinal, 1, i - 1) & UCase(Mid(strTemp, i, 1)) & Mid(strFinal, i + 1)
                isSpace = False
            Else
                strFinal = Mid(strFinal, 1, i - 1) & Mid(strTemp, i, 1) & Mid(strFinal, i + 1)
            End If
        Next i

        PCase = strFinal

Exit_PCase:
        Exit Function

Err_PCase:
        MsgBox(Err.Description & vbCrLf & strText, vbInformation, "PCase function")
    End Function

Private Function empty_line (s As String) As Boolean
	empty_line = Mid(s,1,1) = ";" Or s = ""
End Function

Private Function skip_until (fileNo As Integer, tokens() As String, ByRef s As String) As Boolean
Dim i As Integer

	Do
		Line Input #fileNo, s
		If Not empty_line(s) Then
			For i = LBound(tokens) To UBound(tokens)
				If s = tokens(i) Then
					Exit Do
				End If
			Next i
		End If
	Loop While Not EOF (1)
	skip_until = EOF(fileNo)

End Function

Private Function read_until (fileNo As Integer, token As String, ByRef s As String) As Boolean


	Do
		Line Input #fileNo, s
	Loop While (s <> token And empty_line(s)) And Not EOF (1)
	read_until = EOF(fileNo)

End Function

Private Function ltrim_tabs (s As String) As String
Dim i As Integer

	i = 1
	While Mid(s,i,1) = vbTab
		i = i + 1
	Wend
	ltrim_tabs = Mid(s,i)

End Function

Private Sub ensure_country_and_code (iptc As IPTCStream, _
                                     field As String, _
	                                 value As String, _
	                                 countries As IMDictionary, _
	                                 codes As IMDictionary )

	If field = "Country/Primary Location Code" Then
		If codes.Exists(value) Then
			iptc.Fields.Item("Country/Primary Location Name") = codes(value)
		End If
	ElseIf field = "Country/Primary Location Name" Then
		If countries.Exists(value) Then
			iptc.Fields.Item("Country/Primary Location Code") = countries(value)
		End If
	End If
End Sub

Private Function LoadCountries (countries As IMDictionary, codes As IMDictionary ) As Boolean

On Error GoTo catch

	Dim s As String
	Dim iptcFile As String
	Dim tokens(1 To 3) As String
	Dim start(1 To 1) As String
	Dim codesArray(500) As String ' space enough
	Dim countriesArray(500) As String
	Dim i As Integer


	start(1) = "["
	tokens(1) = "]"
	tokens(2) = vbTab & "ID" & vbTab & "100"
	tokens(3) = vbTab & "ID" & vbTab & "101"

	LoadCountries = True


	iptcFile = GetSetting ("IMatch AP IPTC Writer", "Settings", "IPTCFile","")
	If iptcFile = "" Then
		iptcFile = Environ("ProgramFiles") & "\" & "photools.com\IMatch\imiptctags.ipt"
	End If
	If Dir(iptcFile) = "" Then
		iptcFile = GetFilePath("*.ipt","ipt",,"Please locate the iptc tags file (should be in 'Program Files\photools.com\IMatch\imiptctags.ipt')")
	End If
	If iptcFile = "" Then
		LoadCountries = False
		Exit Function
	End If
	If Dir(iptcFile) = "" Then
		LoadCountries = False
		Exit Function
	Else
		SaveSetting("IMatch AP IPTC Writer", "Settings", "IPTCFile",iptcFile)
	End If


	countries.Clear
	codes.Clear

	Open iptcFile For Input As #1

	While Not EOF (1)
		If Not skip_until(1, start, s) Then
			If Not skip_until (1, tokens, s) Then
				Select Case s
					Case vbTab & "ID" & vbTab & "100"
						i = 0
						While Not read_until (1, "]", s)
							If s <> "]" Then
								codesArray(i) = ltrim_tabs(s)
							Else
								Exit While
							End If
							i = i + 1
						Wend
					Case vbTab & "ID" & vbTab & "101"
						i = 0
						While Not read_until (1, "]", s)
							If s <> "]" Then
								countriesArray(i) = ltrim_tabs(s)
							Else
								Exit While
							End If
							i = i + 1
						Wend
				End Select
			End If
		End If
	Wend


	i = 0
	While codesArray(i) <> ""
		codes (codesArray(i)) = countriesArray(i)
		countries(countriesArray(i)) = codesArray(i)
		i = i + 1
	Wend


	GoTo finally:

catch:
	LoadCountries = False
	MsgBox Err.Description
	Debug.Print Now & ":" & Err.Description

finally:
	Close #1


End Function

'
Private Sub Class_Initialize()
   ' Debug.Print "Class_Initialize"

    If Not LoadCountries (countries, codes) Then
		 MsgBox(Err.Description & vbCrLf , vbInformation, "Error reading countries file")
	End If

End Sub

Private Sub Class_Terminate()
   ' Debug.Print "Class_Terminate"
   ' Detach
End Sub

