Attribute VB_Name = "Strings"
Option Explicit

    ''' <summary>
    ''' -----------------------------------------------------
    ''' Alle Anfangsbuchstaben des Eingabe String strText werden
    ''' in Grobuchstaben umgewandelt alle anderen in Klein-
    ''' buchsraben umgewandelt.
    ''' Das Leerzeichen und das "-" Zeiche dienen als Wort-
    ''' trenner.
    ''' -----------------------------------------------------
    ''' </summary>
    ''' <param name="strText">der Eingabe String</param>
    ''' <returns>den umgewandelten String</returns>
    ''' <remarks></remarks>
    Public Function PCase(ByVal strText As String) As String
        On Error GoTo Err_PCase

        Dim i As Integer, intLen As Integer, strTemp As String, strFinal As String
        Dim isSpace As Boolean

        strTemp = LCase(Trim(strText))
        intLen = Len(Trim(strText))
        strFinal = String(intLen, " ")
        isSpace = True

        For i = 1 To intLen
            If Mid(strTemp, i, 1) = Chr(32) Then
                strFinal = Mid(strFinal, 1, i - 1) & Chr(32) & Mid(strFinal, i + 1)
                isSpace = True
            ElseIf Mid(strTemp, i, 1) = "-" Then
                strFinal = Mid(strFinal, 1, i - 1) & "-" & Mid(strFinal, i + 1)
                isSpace = True
            ElseIf isSpace Then
                strFinal = Mid(strFinal, 1, i - 1) & UCase(Mid(strTemp, i, 1)) & Mid(strFinal, i + 1)
                isSpace = False
            Else
                strFinal = Mid(strFinal, 1, i - 1) & Mid(strTemp, i, 1) & Mid(strFinal, i + 1)
            End If
        Next i

        PCase = strFinal

Exit_PCase:
        Exit Function

Err_PCase:
        MsgBox(Err.Description & vbCrLf & strText, vbInformation, "ProperCase function")
    End Function
